#include "SDL.h"
#include "xmas.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

SDL_Surface *fontbuffer;

FMUSIC_MODULE *mod = NULL;

void initsdl(){
        if(SDL_Init(SDL_INIT_VIDEO)<0){
                printf("Couldn't initialise SDL video: %s\n",SDL_GetError());
                exit(1);
        }

        atexit(SDL_Quit); //Important :D

        screen = SDL_SetVideoMode(640,480,16,SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_FULLSCREEN);
        if(screen==NULL){
                printf("Couldn't set video mode: %s\n",SDL_GetError());
                exit(1);
        }
	SDL_ShowCursor(SDL_DISABLE); //Hide mouse cursor.

        SDL_WM_SetCaption("Merry christmas!","SDL Application");
}

void initfont(){
	int i;
	SDL_Rect area;

	area.x = area.y = 0;
	area.w = area.h = FONTRES;

	fontbuffer = SDL_LoadBMP("images/font.bmp");
	
	if(fontbuffer == NULL){
		printf("Error, could not load font bitmap(images/font.bmp)! SDL returned %s.\n",SDL_GetError());
		exit(1);
	}
	printf("font bitdepth is %d.\n",fontbuffer->format->BytesPerPixel*8);
	
	printf("Loading font...");
	
	for(i=0;i<59;i++){
		font[i] = SDL_CreateRGBSurface(SDL_SWSURFACE, FONTRES, FONTRES, 16, 0, 0, 0, 0); //Set up RGB surface without transparrency.
		SDL_BlitSurface(fontbuffer, &area, font[i], NULL);
		SDL_SetColorKey(font[i], SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(screen->format, 255, 0, 255)); // Set up transparrent color key.
		area.x+=FONTRES;
	}

	printf("done!\n");
}

void inittext(){
	int i;
	int t = 0;
	
	//                 |                                        |
	//Worst text loader in history :D                           //
        textstring[t++] = "#      *** fredd and gamkiller ***";     //
	for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
        textstring[t++] = "#          (un)proudly present";         //
	for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
        textstring[t++] = "#                 BLEH.";                //
	for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
	for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
	textstring[t++] = "   Hello all happy sceners out there!";  //
	textstring[t++] = "#  this was actually supposed to be a";  //
	textstring[t++] = "# proper demo but turned out as more of";//
	textstring[t++] = "#     a little intro thing instead";     //
	textstring[t++] = "#     (much to rv s relief, bahah!)";    //
	for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
	textstring[t++] = "";                                       //
	textstring[t++] = "";                                       //
        textstring[t++] = "# We started making this demo when the"; //
        textstring[t++] = "#    party started, and the time is";    //
        textstring[t++] = "#now about .. 16 02.. deadlines deadline";//
        textstring[t++] = "#           is approaching! ....";      //
	for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
        textstring[t++] = "#  We would like to thank a couple of";  //
	textstring[t++] = " people who have helped us a great deal";//
	textstring[t++] = "#     while making this demo....";       //
        for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
	textstring[t++] = "              ************";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "#             * matricks *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "#             * babywafn *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "#             *   Ilon   *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "#             *    rv    *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "              ************";             //
	for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
	textstring[t++] = "#And uh, while we are discussing neat";  //
	textstring[t++] = " people, here are the greetings...";     //
	for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
	textstring[t++] = "              ************";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "              *   Nord   *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "              *  naitro  *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "              *   Who    *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "              *  Marvin  *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "              * theodore *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "              * Madelene *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "              * tomtefan *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "              *   ollet  *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "              *   diox   *";             //
	textstring[t++] = "";                                       //
	textstring[t++] = "    And ofcourse, the deadline crew!";   //
	textstring[t++] = "";                                       //
	textstring[t++] = "              ************";             //
	for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
	textstring[t++] = "..and everyone in the channels..";       //
	textstring[t++] = "# (square) fulhack,";                    //
	textstring[t++] = "  (square) enelegend,";                  //
	textstring[t++] = "  (square) slackware,";                  //
	textstring[t++] = "  (square) quickbasic and so on...";     //
	for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
	textstring[t++] = "#    Well, we suppose this thing is";        //
	textstring[t++] = "#  starting to bore you, so we'll just";   //
	textstring[t++] = "#   restart this scroller to bore you";
	textstring[t++] = "             even more....";       //
	for(i=0;i<15;i++){ textstring[t++] = ""; }                  //
	textstring[t++] = "#(Press ESC now already!!)";             //
	for(i=0;i<45;i++){ textstring[t++] = ""; }                  //
	textstring[t++] = "No, really, we are not farbrausch,";
	textstring[t++] = "there are no surprises.";
	for(i=0;i<15;i++){ textstring[t++] = ""; }
	for(i=0;i<15;i++){ textstring[t++] = "#"; }                 //
	for(i=0;i<15;i++){ textstring[t++] = "#"; }                 //
	
	                    
	              //145
	
	
}                     

		
void loadbackground(){
	background = SDL_LoadBMP("images/background.bmp");
	if(background == NULL){
		printf("Error, could not load background bitmap(images/background.bmp)! SDL returned %s.\n",SDL_GetError());
		exit(1);
	}
	printf("background bitdepth is %d.\n",background->format->BytesPerPixel*8);
}

void initsnow(){
        int i;
        SDL_Rect area;
        area.x = area.y = 0;
        area.w = area.h = 15;

        snowflake = SDL_LoadBMP("images/snowflake.bmp");
	if(snowflake==NULL){
		printf("Error, could not load snowflake bitmap(images/snowflake.bmp)! SDL returned %s.\n",SDL_GetError());
		exit(1);
	}
	printf("snowflake bitdepth is %d.\n",snowflake->format->BytesPerPixel*8);
	SDL_SetAlpha(snowflake, SDL_SRCALPHA, 200);
        SDL_SetColorKey( snowflake,SDL_SRCCOLORKEY | SDL_RLEACCEL,SDL_MapRGB( screen->format,0,0,0));

	srand(time(NULL));
        
        for( i = 0; i < FLAKES; i++){
                snow[i].x = 1+rand()%640;
                snow[i].y = 1+rand()%480;
                snow[i].l = 1+rand()%3;
        }
}

void initball(){
	int i,tmp;
	printf("Mmmm...balls..\n");
	xmasball = SDL_LoadBMP("images/ball.bmp");
	if(xmasball==NULL){
		printf("Error, could not load christmas ball bitmap(images/ball.bmp)! SDL returned %s.\n",SDL_GetError());
		exit(1);
	}
	printf("christmass ball bitdepth is %d.\n",xmasball->format->BytesPerPixel*8);
	SDL_SetAlpha(xmasball, SDL_SRCALPHA, 128);
	SDL_SetColorKey(xmasball, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB( screen->format, 255, 255, 255));
	
	for(i=0;i<BALLNUM;i++){
		ball[i].x = rand()%640-BALLRES;
		ball[i].y = rand()%480-BALLRES;
		tmp = rand()%2;
		if(tmp==0) tmp = -1;
		ball[i].xv = tmp;
		tmp = rand()%2;
		if(tmp==0) tmp = -1;
		ball[i].yv = tmp;
	}

}

void initsound( void ){
        printf("Starting music...");
        //FMUSIC_MODULE *mod = NULL;

        if (!FSOUND_Init(32000,64,0))
        {
                printf("Error initialising sound");
                exit(1);
        }
                
        mod = FMUSIC_LoadSong("music/jingle.s3m");
                
        if(!mod)
        {       
                printf("Error loading file");
                exit(1);
        }
         
	FMUSIC_PlaySong(mod);

        printf("done!\n");
}

void kill_sound( void ){
	FMUSIC_FreeSong(mod);
        FSOUND_Close();
}

	

void initall(){
	printf("Doing stuff...\n");

	initsdl();
	initfont();
	inittext();
	initsnow();                                                                 
	initball();
	loadbackground();
	initsound();		
	printf("righty!\n");
}
	
